package com.huimv.farm.damsubsidy.test;// 导入相关依赖
import com.alibaba.fastjson.JSONObject;
import com.huimv.farm.damsubsidy.common.utils.SmsUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;

import java.util.HashMap;
import java.util.Map;
import java.util.Random;

/**
 * 短信验证登录示例
 */
public class SmsAuthLogin {

    private static final String ACCESS_KEY_ID = "your_access_key_id";
    private static final String ACCESS_KEY_SECRET = "your_access_key_secret";
    private static final String SIGN_NAME = "your_signature_name";
    private static final String TEMPLATE_CODE = "your_template_code";




    // 保存手机号和验证码的映射
    private static final Map<String, String> phoneCodeMap = new HashMap<>();

    public static void main(String[] args) throws Exception {
        String phoneNumber = "your_phone_number";
        String code = generateRandomCode();

        String mobiles = "13140429955";
        //模板id
        String templateId = "e683346d84234fc1a0816791587a4335";
        //模板里的参数，可多个
        String[] paramss = {code};
        // 调用发送短信的接口
        JSONObject success = SmsUtils.sendSms(mobiles,templateId, paramss);
        Boolean success1 = (Boolean)success.get("success");
        if (success1) {
            // 如果发送成功，将手机号和验证码保存在映射中，便于后续校验
            RedisTemplate<String, Object> redisTemplate = new RedisTemplate<String, Object>();
            redisTemplate.opsForHash();
//            phoneCodeMap.put(phoneNumber, code);
        } else {
            // do something
        }
        
        // 客户端提交的手机号和验证码
        String inputPhoneNumber = "your_input_phone_number";
        String inputCode = "your_input_code";
        // 校验验证码是否正确
        if (checkCode(inputPhoneNumber, inputCode)) {
            // 登录成功
        } else {
            // 登录失败
        }
    }

    /**
     * 生成随机验证码
     */
    private static String generateRandomCode() {
        Random random = new Random();
        String code = "";
        for (int i = 0; i < 6; i++) {
            code += random.nextInt(10);
        }
        return code;
    }



    /**
     * 验证手机号和验证码是否匹配
     */
    private static boolean checkCode(String phoneNumber, String code) {
        String savedCode = phoneCodeMap.get(phoneNumber);
        if (savedCode != null && savedCode.equals(code)) {
            return true;
        }
        return false;
    }

}
